# -*- coding: utf-8 -*-
"""The application's Globals object."""

from luci.controllers.scheme import LuciScheme
from luci.lib.form_utils import FormUtils
from luci.lib.demo_data import ClusterData

__all__ = ['Globals']


class Globals(object):
    """Container for objects available throughout the life of the application.

    One instance of Globals is created during application initialization and
    is available during requests via the 'app_globals' variable.

    """

    def __init__(self):
        """Prepare some common static functions, constants etc."""
        self.form_utils = FormUtils
        self.scheme = LuciScheme
        self.data = ClusterData()

