from luci.model import metadata, DBSession
from luci.model.objects import Node,Cluster,Task
from sqlalchemy.orm.exc import NoResultFound

from luci.lib.ricci_communicator import RicciCommunicator
import luci.lib.ricci_queries as rq

class NodeStatus:
	def __init__(self, node_xml):
		self.name = node_xml.getAttribute('name')
		self.clustered = node_xml.getAttribute('clustered')
		self.online = node_xml.getAttribute('online')
		self.uptime = node_xml.getAttribute('uptime')
		self.votes = node_xml.getAttribute('votes')

class ServiceStatus:
	def __init__(self, svc_xml):
		self.type = 'service'
		self.name = svc_xml.getAttribute('name')
		self.nodename = svc_xml.getAttribute('nodename')
		self.running = svc_xml.getAttribute('running')
		self.failed = svc_xml.getAttribute('failed')
		self.autostart = svc_xml.getAttribute('autostart')
		self.is_vm = svc_xml.getAttribute('vm').lower() == 'true'

class ClusterStatus:
	def __init__(self, status_xml):
		self.alias = status_xml.firstChild.getAttribute('alias')
		self.name = status_xml.firstChild.getAttribute('name')
		self.quorate = status_xml.firstChild.getAttribute('quorate')
		self.votes = status_xml.firstChild.getAttribute('votes')
		self.minQuorum = status_xml.firstChild.getAttribute('minQuorum')
		self.nodes = []
		self.services = []

		for node in status_xml.firstChild.childNodes:
			if node.nodeName == 'node':
				self.nodes.append(NodeStatus(node))
			elif node.nodeName == 'service':
				self.services.append(ServiceStatus(node))
