from tw.api import WidgetsList
import tw.forms as twf
from tw.forms import TableForm, TextField, PasswordField, RadioButtonList, RadioButton, CheckBox, CheckBoxTable, Label, Spacer
import tw.dynforms as twd

__all__ = ["CreateClusterForm", "create_cluster_form"]

class HostForm(twd.GrowingTableFieldSet):
    children = [
        TextField('hostname'),
        PasswordField('password'),
        TextField('port', size=5, default='11111',validator=twf.validators.Int(min=1, max=65535))
    ]

class CreateClusterForm(twd.CustomisedForm):
  children = [
        TextField('cluster_name', validator=twf.validators.NotEmpty),
        HostForm('host_list'),
        RadioButtonList('download_pkgs', options=[('download',"Download Packages"),('local',"Use locally installed packages")], suppress_label = True, default = 'download'),

        CheckBoxTable('opt', options=[('shared_storage', "Enable Shared Storage Support"), ('reboot_nodes', "Reboot nodes before joining cluster"), ('same_passwd', "Check if node passwords are identical")], suppress_label = True, default = ("Enable Shared Storage Support"))
    ]

create_cluster_form = CreateClusterForm('create_cluster_form', action='cluster_create')
